
//Transición del espectro del arco iris con tira leds RGB

//Declaracion de los pines como constantes:
const int ledPinR = 13;   //led rojo conectado al pin 13
const int ledPinV = 12;   //led verde conectado al pin 12
const int ledPinA = 11;   //led azul conectado al pin 11

//Declaracion de los tiempos de pausas como constantes:
const int tiempo1 = 1000; //tiempo de 1000 ms
const int tiempo2 = 20;   //tiempo de 20 ms

//Declaración de las variables necesarias:
int rojo = 0;   //para el color rojo
int verde = 0;  //para el color verde
int azul = 0;   //para el color azul

void setup() {
  //Inicialización de los LEDs
  //Comprobación de cada color por separado
  ponColor(255, 0, 0);  //llama a la función ponColor y pasa el rojo
  delay(tiempo1);       //pausa de 1000 ms
  ponColor(0, 255, 0);  //llama a la función ponColor y pasa el verde
  delay(tiempo1);       //pausa de 1000 ms
  ponColor(0, 0, 255);  //llama a la función ponColor y pasa el azul
  delay(tiempo1);       //pausa de 1000 ms
  //Comprobación con los tres colores a la vez
  ponColor(0, 0, 0);    //llama a la función ponColor y pasa el negro (leds apagados)
  delay(tiempo1);       //pausa de 1000 ms
  ponColor(255, 255, 255);  //llama a la función ponColor y pasa el blanco (leds encendidos)
  delay(tiempo1);       //pausa de 1000 ms
  ponColor(0, 0, 0);    //llama a la función ponColor y pasa el negro (leds apagados)
  delay(tiempo1);       //pausa de 1000 ms
  //Dejamos el color rojo encendido para empezar el loop
  ponColor(255, 0, 0);  //llama a la función ponColor y pasa el rojo 
  delay(tiempo1);       //pausa de 1000 ms
}

void loop() {
  //Se mantiene el rojo al máximo mientras sube el verde
  for (int verde = 0; verde <= 255; verde++) {
    ponColor(255, verde, 0);
    delay(tiempo2);   //pausa de 20 ms
  }
  //Se mantiene el verde al máximo mientras baja el rojo
  for (int rojo = 255; rojo >= 0; rojo--) {
    ponColor(rojo, 255, 0);
    delay(tiempo2);   //pausa de 20 ms
  }
  //Se mantiene el verde al máximo mientras sube el azul
  for (int azul = 0; azul <= 255; azul++) {
    ponColor(0, 255, azul);
    delay(tiempo2);   //pausa de 20 ms
  }
  //Se mantiene el azul al máximo mientras baja el verde
  for (int verde = 255; verde >= 0; verde--) {
    ponColor(0, verde, 255);
    delay(tiempo2);   //pausa de 20 ms
  }
  //Se mantiene el azul al maximo mientras sube el rojo
  for (int rojo = 0; rojo <= 255; rojo++) {
    ponColor(rojo, 0, 255);
    delay(tiempo2);   //pausa de 20 ms
  }
  //Se mantiene el rojo al máximo mientras baja el azul
  for (int azul = 255; azul >= 0; azul--) {
    ponColor(255, 0, azul);
    if (azul == 0) {
      delay(tiempo2*5); //pausa de 100 ms
    }
    else {
      delay(tiempo2);   //pausa de 20 ms
    }
  }
}

void ponColor(int red, int green, int blue)
{
  analogWrite(ledPinR, red);
  analogWrite(ledPinV, green);
  analogWrite(ledPinA, blue);
}
